Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceitd.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceitd.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceitd.F90	(revision 8486)
@@ -11,5 +11,5 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                   LIM3 sea-ice model
+   !!   'key_lim3'                                       LIM3 sea-ice model
    !!----------------------------------------------------------------------
    !!   ice_itd_rem   :
@@ -18,16 +18,16 @@
    !!   ice_itd_shiftice :
    !!----------------------------------------------------------------------
-   USE par_oce          ! ocean parameters
-   USE dom_oce          ! ocean domain
-   USE phycst           ! physical constants (ocean directory) 
-   USE ice1D            ! LIM-3 thermodynamic variables
-   USE ice              ! LIM-3 variables
-   USE icectl           ! conservation tests
-   USE icetab
+   USE par_oce        ! ocean parameters
+   USE dom_oce        ! ocean domain
+   USE phycst         ! physical constants 
+   USE ice1D          ! sea-ice: thermodynamic variables
+   USE ice            ! sea-ice: variables
+   USE icectl         ! sea-ice: conservation tests
+   USE icetab         ! sea-ice: convert 1D<=>2D
    !
-   USE prtctl           ! Print control
-   USE in_out_manager   ! I/O manager
-   USE lib_mpp          ! MPP library
-   USE lib_fortran      ! to use key_nosignedzero
+   USE prtctl         ! Print control
+   USE in_out_manager ! I/O manager
+   USE lib_mpp        ! MPP library
+   USE lib_fortran    ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -38,5 +38,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2010)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: iceitd.F90 8420 2017-08-08 12:18:46Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -86,5 +86,5 @@
       !  1) Identify grid cells with ice
       !-----------------------------------------------------------------------------------------------
-      nidx = 0 ; idxice(:) = 0
+      nidx = 0   ;   idxice(:) = 0
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -118,5 +118,5 @@
          ! --- New boundaries for category 1:jpl-1 --- !
          DO jl = 1, jpl - 1
-
+            !
             DO ji = 1, nidx
                !
@@ -134,5 +134,5 @@
                   zhbnew(ji,jl) = hi_max(jl)
                ENDIF
-            
+               !
                ! --- 2 conditions for remapping --- !
                ! 1) hn(t+1)+espi < Hn* < hn+1(t+1)-epsi               
@@ -148,5 +148,5 @@
             END DO
          END DO
-         
+         !
          ! --- New boundaries for category jpl --- !
          DO ji = 1, nidx
@@ -164,5 +164,5 @@
             IF( ht_ib_2d(ji,1) > ( hi_max(1) - epsi10 ) )   idxice(ji) = 0
          END DO
-
+         !
          !-----------------------------------------------------------------------------------------------
          !  3) Identify cells where remapping
@@ -178,5 +178,5 @@
          idxice(:) = idxice2(:)
          nidx      = nidx2
-         
+         !
       ENDIF
    
@@ -186,27 +186,27 @@
       !-----------------------------------------------------------------------------------------------
       IF( nidx > 0 ) THEN
-
-         zhb0(:) = hi_max(0) ; zhb1(:) = hi_max(1)
-         g0(:,:) = 0._wp     ; g1(:,:) = 0._wp 
-         hL(:,:) = 0._wp     ; hR(:,:) = 0._wp 
-         
+         !
+         zhb0(:) = hi_max(0)   ;   zhb1(:) = hi_max(1)
+         g0(:,:) = 0._wp       ;   g1(:,:) = 0._wp 
+         hL(:,:) = 0._wp       ;   hR(:,:) = 0._wp 
+         !
          DO jl = 1, jpl
-
+            !
             CALL tab_2d_1d( nidx, idxice(1:nidx), ht_ib_1d(1:nidx), ht_i_b(:,:,jl) )
             CALL tab_2d_1d( nidx, idxice(1:nidx), ht_i_1d (1:nidx), ht_i(:,:,jl)   )
             CALL tab_2d_1d( nidx, idxice(1:nidx), a_i_1d  (1:nidx), a_i(:,:,jl)    )
             CALL tab_2d_1d( nidx, idxice(1:nidx), v_i_1d  (1:nidx), v_i(:,:,jl)    )
-
+            !
             IF( jl == 1 ) THEN
-               
+               !  
                ! --- g(h) for category 1 --- !
-               CALL ice_itd_glinear( zhb0(1:nidx), zhb1(1:nidx), ht_ib_1d(1:nidx), a_i_1d(1:nidx),  &   ! in
-                  &                  g0(1:nidx,1), g1(1:nidx,1), hL(1:nidx,1)    , hR(1:nidx,1) )       ! out
-               
+               CALL ice_itd_glinear( zhb0(1:nidx)  , zhb1(1:nidx)  , ht_ib_1d(1:nidx)  , a_i_1d(1:nidx)  ,  &   ! in
+                  &                  g0  (1:nidx,1), g1  (1:nidx,1), hL      (1:nidx,1), hR    (1:nidx,1)   )   ! out
+                  !
                ! Area lost due to melting of thin ice
                DO ji = 1, nidx
-                  
+                  !
                   IF( a_i_1d(ji) > epsi10 ) THEN
-                     
+                     !
                      zdh0 =  ht_i_1d(ji) - ht_ib_1d(ji)                
                      IF( zdh0 < 0.0 ) THEN      !remove area from category 1
@@ -214,5 +214,5 @@
                         !Integrate g(1) from 0 to dh0 to estimate area melted
                         zetamax = MIN( zdh0, hR(ji,1) ) - hL(ji,1)
-                        
+                        !
                         IF( zetamax > 0.0 ) THEN
                            zx1    = zetamax
@@ -227,24 +227,24 @@
                            v_i_1d(ji)  = a_i_1d(ji) * ht_i_1d(ji) ! clem-useless ?
                         ENDIF
-                        
+                        !
                      ELSE ! if ice accretion zdh0 > 0
                         ! zhbnew was 0, and is shifted to the right to account for thin ice growth in openwater (F0 = f1)
                         zhbnew(ji,0) = MIN( zdh0, hi_max(1) ) 
                      ENDIF
-                     
+                     !
                   ENDIF
-                  
+                  !
                END DO
-
+               !
                CALL tab_1d_2d( nidx, idxice(1:nidx), ht_i_1d (1:nidx), ht_i(:,:,jl)   )
                CALL tab_1d_2d( nidx, idxice(1:nidx), a_i_1d  (1:nidx), a_i(:,:,jl)    )
                CALL tab_1d_2d( nidx, idxice(1:nidx), v_i_1d  (1:nidx), v_i(:,:,jl)    )
-               
+               !
             ENDIF ! jl=1
-            
+            !
             ! --- g(h) for each thickness category --- !  
-            CALL ice_itd_glinear( zhbnew(1:nidx,jl-1), zhbnew(1:nidx,jl), ht_i_1d(1:nidx), a_i_1d(1:nidx),  &  ! in
-               &                  g0(1:nidx,jl)      , g1(1:nidx,jl)    , hL(1:nidx,jl)  , hR(1:nidx,jl) )     ! out
-
+            CALL ice_itd_glinear( zhbnew(1:nidx,jl-1), zhbnew(1:nidx,jl), ht_i_1d(1:nidx)   , a_i_1d(1:nidx)   ,  &   ! in
+               &                  g0    (1:nidx,jl  ), g1    (1:nidx,jl), hL     (1:nidx,jl), hR    (1:nidx,jl)   )   ! out
+            !
          END DO
          
@@ -253,7 +253,7 @@
          !-----------------------------------------------------------------------------------------------
          DO jl = 1, jpl - 1
-            
+            !
             DO ji = 1, nidx
-               
+               !
                ! left and right integration limits in eta space
                IF (zhbnew(ji,jl) > hi_max(jl)) THEN ! Hn* > Hn => transfer from jl to jl+1
@@ -267,5 +267,5 @@
                ENDIF
                zetamax = MAX( zetamax, zetamin ) ! no transfer if etamax < etamin
-               
+               !
                zx1  = zetamax - zetamin
                zwk1 = zetamin * zetamin
@@ -278,5 +278,5 @@
                zdaice(ji,jl) = g1(ji,jcat)*zx2 + g0(ji,jcat)*zx1
                zdvice(ji,jl) = g1(ji,jcat)*zx3 + g0(ji,jcat)*zx2 + zdaice(ji,jl)*hL(ji,jcat)
-               
+               !
             END DO
          END DO
@@ -305,13 +305,13 @@
             ENDIF
          END DO
-
+         !
          CALL tab_1d_2d( nidx, idxice(1:nidx), ht_i_1d (1:nidx), ht_i(:,:,1)   )
          CALL tab_1d_2d( nidx, idxice(1:nidx), a_i_1d  (1:nidx), a_i(:,:,1)    )
          CALL tab_1d_2d( nidx, idxice(1:nidx), a_ip_1d (1:nidx), a_ip(:,:,1)    )
-        
+         !
       ENDIF
-
-      IF( ln_limdiachk ) CALL ice_cons_hsm(1, 'iceitd_rem', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
+      !
+      IF( ln_limdiachk )   CALL ice_cons_hsm(1, 'iceitd_rem', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      !
    END SUBROUTINE ice_itd_rem
 
@@ -325,5 +325,4 @@
       !! ** Method  :   g(h) is linear and written as: g(eta) = g1(eta) + g0
       !!                with eta = h - HL
-      !!                
       !!------------------------------------------------------------------
       REAL(wp), DIMENSION(:), INTENT(in   ) ::   HbL, HbR      ! left and right category boundaries
@@ -333,4 +332,5 @@
       !
       INTEGER  ::   ji           ! horizontal indices
+      REAL(wp) ::   z1_3 , z2_3  ! 1/3 , 2/3
       REAL(wp) ::   zh13         ! HbL + 1/3 * (HbR - HbL)
       REAL(wp) ::   zh23         ! HbL + 2/3 * (HbR - HbL)
@@ -339,36 +339,39 @@
       !!------------------------------------------------------------------
       !
-         DO ji = 1, nidx
-            !
-            IF( paice(ji) > epsi10  .AND. phice(ji) > 0._wp )  THEN
-
-               ! Initialize hL and hR
-               phL(ji) = HbL(ji)
-               phR(ji) = HbR(ji)
-
-               ! Change hL or hR if hice falls outside central third of range,
-               ! so that hice is in the central third of the range [HL HR]
-               zh13 = 1.0 / 3.0 * ( 2.0 * phL(ji) +       phR(ji) )
-               zh23 = 1.0 / 3.0 * (       phL(ji) + 2.0 * phR(ji) )
-
-               IF    ( phice(ji) < zh13 ) THEN   ;   phR(ji) = 3._wp * phice(ji) - 2._wp * phL(ji) ! move HR to the left
-               ELSEIF( phice(ji) > zh23 ) THEN   ;   phL(ji) = 3._wp * phice(ji) - 2._wp * phR(ji) ! move HL to the right
-               ENDIF
-
-               ! Compute coefficients of g(eta) = g0 + g1*eta
-               zdhr = 1._wp / (phR(ji) - phL(ji))
-               zwk1 = 6._wp * paice(ji) * zdhr
-               zwk2 = ( phice(ji) - phL(ji) ) * zdhr
-               pg0(ji) = zwk1 * ( 2._wp / 3._wp - zwk2 )      ! Eq. 14
-               pg1(ji) = 2._wp * zdhr * zwk1 * ( zwk2 - 0.5 ) ! Eq. 14
-               !
-            ELSE  ! remap_flag = .false. or a_i < epsi10 
-               phL(ji) = 0._wp
-               phR(ji) = 0._wp
-               pg0(ji) = 0._wp
-               pg1(ji) = 0._wp
-            ENDIF
-            !
-         END DO
+      z1_3 = 1._wp / 3._wp
+      z2_3 = 2._wp / 3._wp
+      !
+      DO ji = 1, nidx
+         !
+         IF( paice(ji) > epsi10  .AND. phice(ji) > 0._wp )  THEN
+            !
+            ! Initialize hL and hR
+            phL(ji) = HbL(ji)
+            phR(ji) = HbR(ji)
+            !
+            ! Change hL or hR if hice falls outside central third of range,
+            ! so that hice is in the central third of the range [HL HR]
+            zh13 = z1_3 * ( 2._wp * phL(ji) +         phR(ji) )
+            zh23 = z1_3 * (         phL(ji) + 2._wp * phR(ji) )
+            !
+            IF    ( phice(ji) < zh13 ) THEN   ;   phR(ji) = 3._wp * phice(ji) - 2._wp * phL(ji) ! move HR to the left
+            ELSEIF( phice(ji) > zh23 ) THEN   ;   phL(ji) = 3._wp * phice(ji) - 2._wp * phR(ji) ! move HL to the right
+            ENDIF
+            !
+            ! Compute coefficients of g(eta) = g0 + g1*eta
+            zdhr = 1._wp / (phR(ji) - phL(ji))
+            zwk1 = 6._wp * paice(ji) * zdhr
+            zwk2 = ( phice(ji) - phL(ji) ) * zdhr
+            pg0(ji) = zwk1 * ( z2_3 - zwk2 )                    ! Eq. 14
+            pg1(ji) = 2._wp * zdhr * zwk1 * ( zwk2 - 0.5_wp )   ! Eq. 14
+            !
+         ELSE  ! remap_flag = .false. or a_i < epsi10 
+            phL(ji) = 0._wp
+            phR(ji) = 0._wp
+            pg0(ji) = 0._wp
+            pg1(ji) = 0._wp
+         ENDIF
+         !
+      END DO
       !
    END SUBROUTINE ice_itd_glinear
@@ -381,18 +384,14 @@
       !! ** Purpose :   shift ice across category boundaries, conserving everything
       !!              ( area, volume, energy, age*vol, and mass of salt )
-      !!
-      !! ** Method  :
       !!------------------------------------------------------------------
       INTEGER , DIMENSION(:,:), INTENT(in) ::   kdonor   ! donor category index
       REAL(wp), DIMENSION(:,:), INTENT(in) ::   pdaice   ! ice area transferred across boundary
       REAL(wp), DIMENSION(:,:), INTENT(in) ::   pdvice   ! ice volume transferred across boundary
-
-      INTEGER ::   ii,ij, ji, jj, jl, jl2, jl1, jk   ! dummy loop indices
-
-      REAL(wp), DIMENSION(jpij,jpl) ::   zaTsfn
-      REAL(wp), DIMENSION(jpij)     ::   zworka            ! temporary array used here
-      REAL(wp), DIMENSION(jpij)     ::   zworkv            ! temporary array used here
-
+      !
+      INTEGER  ::   ji, jj, jl, jk     ! dummy loop indices
+      INTEGER  ::   ii, ij, jl2, jl1   ! local integers
       REAL(wp) ::   ztrans             ! ice/snow transferred
+      REAL(wp), DIMENSION(jpij)     ::   zworka, zworkv   ! workspace
+      REAL(wp), DIMENSION(jpij,jpl) ::   zaTsfn           !  -    -
       !!------------------------------------------------------------------
          
@@ -421,52 +420,57 @@
       DO jl = 1, jpl - 1
          DO ji = 1, nidx
-            
+            !
             jl1 = kdonor(ji,jl)
-            IF    ( jl1 == jl  ) THEN   ;   jl2 = jl1+1
-            ELSE                        ;   jl2 = jl 
-            ENDIF
-
-            rswitch    = MAX( 0._wp , SIGN( 1._wp , v_i_2d(ji,jl1) - epsi10 ) )
-            zworkv(ji) = pdvice(ji,jl) / MAX( v_i_2d(ji,jl1), epsi10 ) * rswitch
-
-            rswitch    = MAX( 0._wp , SIGN( 1._wp , a_i_2d(ji,jl1) - epsi10 ) )
-            zworka(ji) = pdaice(ji,jl) / MAX( a_i_2d(ji,jl1), epsi10 ) * rswitch        
-               
-            ! Ice areas
-            a_i_2d(ji,jl1) = a_i_2d(ji,jl1) - pdaice(ji,jl)
+            IF ( jl1 == jl  ) THEN   ;   jl2 = jl1+1
+            ELSE                     ;   jl2 = jl 
+            ENDIF
+            !
+!!gm use of rswitch not faster as there is already IF in the DO-loop ==>>> use IF which is more readable
+!            rswitch    = MAX( 0._wp , SIGN( 1._wp , v_i_2d(ji,jl1) - epsi10 ) )
+!            zworkv(ji) = pdvice(ji,jl) / MAX( v_i_2d(ji,jl1), epsi10 ) * rswitch
+!            !
+!            rswitch    = MAX( 0._wp , SIGN( 1._wp , a_i_2d(ji,jl1) - epsi10 ) )
+!            zworka(ji) = pdaice(ji,jl) / MAX( a_i_2d(ji,jl1), epsi10 ) * rswitch        
+
+            IF( v_i_2d(ji,jl1) >= epsi10 ) THEN   ;   zworkv(ji) = pdvice(ji,jl) / v_i_2d(ji,jl1)
+            ELSE                                  ;   zworkv(ji) = 0._wp
+            ENDIF
+            IF( a_i_2d(ji,jl1) >= epsi10 ) THEN   ;   zworka(ji) = pdaice(ji,jl) / a_i_2d(ji,jl1)
+            ELSE                                  ;   zworka(ji) = 0._wp
+            ENDIF
+!!gm end
+            !
+            a_i_2d(ji,jl1) = a_i_2d(ji,jl1) - pdaice(ji,jl)       ! Ice areas
             a_i_2d(ji,jl2) = a_i_2d(ji,jl2) + pdaice(ji,jl)
-               
-            ! Ice volumes
-            v_i_2d(ji,jl1) = v_i_2d(ji,jl1) - pdvice(ji,jl) 
+            !
+            v_i_2d(ji,jl1) = v_i_2d(ji,jl1) - pdvice(ji,jl)       ! Ice volumes
             v_i_2d(ji,jl2) = v_i_2d(ji,jl2) + pdvice(ji,jl)
-            
-            ! Snow volumes
-            ztrans         = v_s_2d(ji,jl1) * zworkv(ji)
+            !
+            ztrans         = v_s_2d(ji,jl1) * zworkv(ji)          ! Snow volumes
             v_s_2d(ji,jl1) = v_s_2d(ji,jl1) - ztrans
             v_s_2d(ji,jl2) = v_s_2d(ji,jl2) + ztrans 
-                       
-            ! Ice age 
-            ztrans             = oa_i_2d(ji,jl1) * pdaice(ji,jl) !!clem: should be * zworka(ji) but it does not work
+            !          
+            !                                                     ! Ice age 
+            ztrans             = oa_i_2d(ji,jl1) * pdaice(ji,jl)  !!clem: should be * zworka(ji) but it does not work ????
             oa_i_2d(ji,jl1)    = oa_i_2d(ji,jl1) - ztrans
             oa_i_2d(ji,jl2)    = oa_i_2d(ji,jl2) + ztrans
-            
-            ! Ice salinity
-            ztrans             = smv_i_2d(ji,jl1) * zworkv(ji)
+            !
+            ztrans             = smv_i_2d(ji,jl1) * zworkv(ji)    ! Ice salinity
+
             smv_i_2d(ji,jl1)   = smv_i_2d(ji,jl1) - ztrans
             smv_i_2d(ji,jl2)   = smv_i_2d(ji,jl2) + ztrans
-            
-            ! Surface temperature
-            ztrans          = t_su_2d(ji,jl1) * pdaice(ji,jl) !!clem: should be * zworka(ji) but it does not work
+            !
+            !                                                     ! Surface temperature
+            ztrans          = t_su_2d(ji,jl1) * pdaice(ji,jl)     !!clem: should be * zworka(ji) but it does not work ????
             zaTsfn(ji,jl1)  = zaTsfn(ji,jl1) - ztrans
             zaTsfn(ji,jl2)  = zaTsfn(ji,jl2) + ztrans
-               
+            !  
             ! MV MP 2016 
             IF ( nn_pnd_scheme > 0 ) THEN
-               ! Pond fraction
+               !                                                  ! Pond fraction
                ztrans          = a_ip_2d(ji,jl1) * pdaice(ji,jl) !!clem: should be * zworka(ji) but it does not work
                a_ip_2d(ji,jl1) = a_ip_2d(ji,jl1) - ztrans
                a_ip_2d(ji,jl2) = a_ip_2d(ji,jl2) + ztrans
-               
-               ! Pond volume (also proportional to da/a)
+               !                                                  ! Pond volume (also proportional to da/a)
                ztrans          = v_ip_2d(ji,jl1) * pdaice(ji,jl) !!clem: should be * zworka(ji) but it does not work
                v_ip_2d(ji,jl1) = v_ip_2d(ji,jl1) - ztrans
@@ -474,19 +478,17 @@
             ENDIF
             ! END MV MP 2016 
-               
-         END DO
-
-         ! Snow heat content
-         DO jk = 1, nlay_s
-
+         END DO
+         !
+         DO jk = 1, nlay_s         !--- Snow heat content
+            !
             DO ji = 1, nidx
                ii = MOD( idxice(ji) - 1, jpi ) + 1
                ij = ( idxice(ji) - 1 ) / jpi + 1
-
+               !
                jl1 = kdonor(ji,jl)
                IF(jl1 == jl) THEN  ;  jl2 = jl+1
                ELSE                ;  jl2 = jl
                ENDIF
-               
+               !
                ztrans            = e_s(ii,ij,jk,jl1) * zworkv(ji)
                e_s(ii,ij,jk,jl1) = e_s(ii,ij,jk,jl1) - ztrans
@@ -495,16 +497,14 @@
          END DO
 
-         
-         ! Ice heat content
-         DO jk = 1, nlay_i
+         DO jk = 1, nlay_i         !--- Ice heat content
             DO ji = 1, nidx
                ii = MOD( idxice(ji) - 1, jpi ) + 1
                ij = ( idxice(ji) - 1 ) / jpi + 1
-               
+               !
                jl1 = kdonor(ji,jl)
                IF(jl1 == jl) THEN  ;  jl2 = jl+1
                ELSE                ;  jl2 = jl
                ENDIF
-               
+               !
                ztrans            = e_i(ii,ij,jk,jl1) * zworkv(ji)
                e_i(ii,ij,jk,jl1) = e_i(ii,ij,jk,jl1) - ztrans
@@ -512,5 +512,5 @@
             END DO
          END DO
-         
+         !
       END DO                   ! boundaries, 1 to jpl-1
       
@@ -521,5 +521,5 @@
          DO ji = 1, nidx
             IF ( a_i_2d(ji,jl) > epsi10 ) THEN 
-               ht_i_2d(ji,jl)  =  v_i_2d   (ji,jl) / a_i_2d(ji,jl) 
+               ht_i_2d(ji,jl)  =  v_i_2d(ji,jl) / a_i_2d(ji,jl) 
                t_su_2d(ji,jl)  =  zaTsfn(ji,jl) / a_i_2d(ji,jl) 
             ELSE
@@ -529,15 +529,14 @@
          END DO
       END DO
-      
-      CALL tab_2d_3d( nidx, idxice(1:nidx), ht_i_2d (1:nidx,1:jpl), ht_i   )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), a_i_2d  (1:nidx,1:jpl), a_i    )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), v_i_2d  (1:nidx,1:jpl), v_i    )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), v_s_2d  (1:nidx,1:jpl), v_s    )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), oa_i_2d (1:nidx,1:jpl), oa_i   )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), smv_i_2d(1:nidx,1:jpl), smv_i  )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), a_ip_2d (1:nidx,1:jpl), a_ip   )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), v_ip_2d (1:nidx,1:jpl), v_ip   )
-      CALL tab_2d_3d( nidx, idxice(1:nidx), t_su_2d (1:nidx,1:jpl), t_su   )
-
+      !
+      CALL tab_2d_3d( nidx, idxice(1:nidx), ht_i_2d (1:nidx,1:jpl), ht_i  )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), a_i_2d  (1:nidx,1:jpl), a_i   )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), v_i_2d  (1:nidx,1:jpl), v_i   )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), v_s_2d  (1:nidx,1:jpl), v_s   )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), oa_i_2d (1:nidx,1:jpl), oa_i  )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), smv_i_2d(1:nidx,1:jpl), smv_i )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), a_ip_2d (1:nidx,1:jpl), a_ip  )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), v_ip_2d (1:nidx,1:jpl), v_ip  )
+      CALL tab_2d_3d( nidx, idxice(1:nidx), t_su_2d (1:nidx,1:jpl), t_su  )
       !
    END SUBROUTINE ice_itd_shiftice
@@ -559,17 +558,13 @@
       REAL(wp), DIMENSION(jpij,jpl-1) ::   zdaice, zdvice   ! ice area and volume transferred
       !!------------------------------------------------------------------
-      
-      DO jl = 1, jpl-1
-         jdonor(:,jl) = 0
-         zdaice(:,jl) = 0._wp
-         zdvice(:,jl) = 0._wp
-      END DO
-
-      !---------------------------------------
-      ! identify thicknesses that are too big
-      !---------------------------------------
-      DO jl = 1, jpl - 1
-
-         nidx = 0 ; idxice(:) = 0
+      !
+      jdonor(:,:) = 0
+      zdaice(:,:) = 0._wp
+      zdvice(:,:) = 0._wp
+      !
+      !                       !---------------------------------------
+      DO jl = 1, jpl-1        ! identify thicknesses that are too big
+         !                    !---------------------------------------
+         nidx = 0   ;   idxice(:) = 0
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -578,11 +573,11 @@
                   idxice( nidx ) = (jj - 1) * jpi + ji                  
                ENDIF
-            ENDDO
-         ENDDO
-         
+            END DO
+         END DO
+         !
 !!clem   CALL tab_2d_1d( nidx, idxice(1:nidx), ht_i_1d (1:nidx), ht_i(:,:,jl)   )
          CALL tab_2d_1d( nidx, idxice(1:nidx), a_i_1d  (1:nidx), a_i(:,:,jl)    )
          CALL tab_2d_1d( nidx, idxice(1:nidx), v_i_1d  (1:nidx), v_i(:,:,jl)    )
-
+         !
          DO ji = 1, nidx
             jdonor(ji,jl)  = jl 
@@ -597,7 +592,6 @@
             zdaice(ji,jl)  = a_i_1d(ji) * 0.5_wp
             zdvice(ji,jl)  = v_i_1d(ji) - zdaice(ji,jl) * ( hi_max(jl) + hi_max(jl-1) ) * 0.5_wp
-            
-         END DO
-
+         END DO
+         !
          IF( nidx > 0 ) THEN
             CALL ice_itd_shiftice( jdonor(1:nidx,:), zdaice(1:nidx,:), zdvice(1:nidx,:) )  ! Shift jl=>jl+1
@@ -610,9 +604,7 @@
       END DO
 
-      !-----------------------------------------
-      ! Identify thicknesses that are too small
-      !-----------------------------------------
-      DO jl = jpl - 1, 1, -1
-
+      !                       !-----------------------------------------
+      DO jl = jpl-1, 1, -1    ! Identify thicknesses that are too small
+         !                    !-----------------------------------------
          nidx = 0 ; idxice(:) = 0
          DO jj = 1, jpj
@@ -622,7 +614,7 @@
                   idxice( nidx ) = (jj - 1) * jpi + ji                  
                ENDIF
-            ENDDO
-         ENDDO
-
+            END DO
+         END DO
+         !
          CALL tab_2d_1d( nidx, idxice(1:nidx), a_i_1d  (1:nidx), a_i(:,:,jl+1)    ) ! jl+1 is ok
          CALL tab_2d_1d( nidx, idxice(1:nidx), v_i_1d  (1:nidx), v_i(:,:,jl+1)    ) ! jl+1 is ok
@@ -632,5 +624,5 @@
             zdvice(ji,jl) = v_i_1d(ji)
          END DO
-         
+         !
          IF( nidx > 0 ) THEN
             CALL ice_itd_shiftice( jdonor(1:nidx,:), zdaice(1:nidx,:), zdvice(1:nidx,:) )  ! Shift jl+1=>jl
@@ -640,10 +632,15 @@
             zdvice(1:nidx,jl) = 0._wp
          ENDIF
-
+         !
       END DO
       !
    END SUBROUTINE ice_itd_reb
 
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option :         Empty module          NO LIM sea-ice model
+   !!----------------------------------------------------------------------
 #endif
+
    !!======================================================================
 END MODULE iceitd
